﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectElectricLocomotive.Drawnings
{
    /// <summary>
    /// Сравнение по цвету, скорости, весу
    /// </summary>
    public class DrawningLocomotiveCompareByColor : IComparer<DrawningLocomotive?>
    {
        public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
        {
            if (x == null && y == null) return 0;
            if (x == null || x.EntityLocomotive == null)
            {
                return 1;
            }

            if (y == null || y.EntityLocomotive == null)
            {
                return -1;
            }

            if (ToHex(x.EntityLocomotive.BodyColor) != ToHex(y.EntityLocomotive.BodyColor))
            {
                return String.Compare(ToHex(x.EntityLocomotive.BodyColor), ToHex(y.EntityLocomotive.BodyColor),
                    StringComparison.Ordinal);
            }

            var speedCompare = x.EntityLocomotive.Speed.CompareTo(y.EntityLocomotive.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }

            return x.EntityLocomotive.Weight.CompareTo(y.EntityLocomotive.Weight);
        }

        private static String ToHex(Color c) => $"#{c.R:X2}{c.G:X2}{c.B:X2}";
    }
}

