﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectElectricLocomotive.Drawnings;

/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawningLocomotiveCompareByType : IComparer<DrawningLocomotive?>
{
    public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
    {
        if (x == null || x.EntityLocomotive == null)
        {
            return -1;
        }
        if (y == null || y.EntityLocomotive == null)
        {
            return 1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }
        var speedCompare = x.EntityLocomotive.Speed.CompareTo(y.EntityLocomotive.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityLocomotive.Weight.CompareTo(y.EntityLocomotive.Weight);
    }
}

