﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectElectricLocomotive.MovementStrategy;

/// <summary>
/// Интерфейс для работы с перемещаемыми объектами
/// </summary>
public interface IMovableObject
{

    /// <summary>
    /// Получение координаты объекта
    /// </summary>
    ObjectParameters? GetObjectPosition { get; }

    /// <summary>
    /// Шаг объекта
    /// </summary>
    int GetStep { get; }

    /// <summary>
    /// Попытка переместить объект в указанном направлении
    /// </summary>
    /// <param name="direction">направление</param>
    /// <returns>true - объект перемещен , false - перемещение невозможно</returns>
    bool TryMoveObject(MovementDirection direction);

}
